/*
* Auther: 醉悠枫
* Mail : flymaple@gmail.com
* Version: 1.0
* Map对象
*/
function Map(){
this.elements = {};
this.idx = 0;
 
//获取Map元素个数
this.size = function() {
  return this.idx;
},

//判断Map是否为空
this.isEmpty = function() {
return (this.idx < 1);
},

//删除Map所有元素
this.clear = function() {
this.elements = {};
this.idx = 0;
},

//向Map中增加元素（key, value) 
this.put = function(_key, _value) {
	var e = this.elements[_key],o = {
		key : _key,
		value : _value
	};
	if(!e) this.idx +=1;
	this.elements[_key] = o;
},

//删除指定key的元素，成功返回true，失败返回false
this.remove = function(_key) {
var bln = false,e=this.elements[_key];
try {  
if(e){
	this.idx-=1;
	delete this.elements[_key];
}
}catch(e){
bln = false;  
}
return bln;
},

//获取指定key的元素值value，失败返回null
this.get = function(_key) {
var e=this.elements[_key];
try{
if(e){
	return e.value;
}
}catch(e){
}
return null;
},

//判断Map中是否含有指定key的元素
this.containsKey = function(_key) {
return typeof this.elements[_key] != 'undefined';
},
   
//判断Map中是否含有指定value的元素
this.containsValue = function(_value) {
var bln = false;
try {
for (var k in this.elements) {  
if (this.elements[k].value == _value){
bln = true;
}
}
}catch(e) {
bln = false;  
}
return bln;
},
 
//获取Map中所有key的数组（array）
this.keys = function() {
var arr = new Array();
for (var k in this.elements) {  
arr.push(k);
}
return arr;
},

//获取Map中所有value的数组（array）
this.values = function() {
var arr = new Array();
for (var k in this.elements) {  
arr.push(this.elements[k].value);
}
return arr;
};

this.each = function(f){
	var i=0;
	 for (var k in this.elements) {  
	 	var o = this.elements[k];
	 	if(o){
	 		try{
	 			f.call(null,o.value,o.key,i++);
	 		}catch(e){alert(e)}
	 	}
	 }
}
}